from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, String, Float

Plotter3_Py_V0_1_0 = CommandToolBuilder(tool="plotter3.py", base_command=["plotter3.py"], inputs=[ToolInput(tag="in_no_save", input_type=Boolean(optional=True), prefix="-nosave", doc=InputDocumentation(doc=": do not save the figure as a pdf (instead plot to screen)")), ToolInput(tag="in_starting_position_plot", input_type=Int(optional=True), prefix="-s", doc=InputDocumentation(doc=": the starting position to plot (0)")), ToolInput(tag="in_ending_position_plot", input_type=Int(optional=True), prefix="-e", doc=InputDocumentation(doc=": the ending position of the plot (contig length)")), ToolInput(tag="in_spo", input_type=Boolean(optional=True), prefix="-spo", doc=InputDocumentation(doc=": sub plots on, recursive search for errors (off)")), ToolInput(tag="in_pt", input_type=String(optional=True), prefix="-pt", doc=InputDocumentation(doc=": plot type 'i'nsert 'k'mer 'p'lacement 'd'epth (-pt dpkt)")), ToolInput(tag="in_dsw", input_type=Int(optional=True), prefix="-dsw", doc=InputDocumentation(doc=": depth smoothing window, averaging over position (-dsw 10000)")), ToolInput(tag="in_psw", input_type=Int(optional=True), prefix="-psw", doc=InputDocumentation(doc=": placement smoothing window (-psw 1000)")), ToolInput(tag="in_ksw", input_type=Int(optional=True), prefix="-ksw", doc=InputDocumentation(doc=": kmer smoothing window (-ksw 1000)")), ToolInput(tag="in_is_w", input_type=Int(optional=True), prefix="-isw", doc=InputDocumentation(doc=": insert smoothing window (-ksw 1000)")), ToolInput(tag="in_tp", input_type=Float(optional=True), prefix="-tp", doc=InputDocumentation(doc=": threshold percentage, see paper (-tp 0.01)")), ToolInput(tag="in_tw", input_type=Int(optional=True), prefix="-tw", doc=InputDocumentation(doc=": threshold width, see paper (-tw 1000)")), ToolInput(tag="in_td", input_type=Float(optional=True), prefix="-td", doc=InputDocumentation(doc=": threshold depth, see paper (-td -5.0)")), ToolInput(tag="in_std", input_type=Float(optional=True), prefix="-std", doc=InputDocumentation(doc=": subplot threshold depth (-std -30.0)")), ToolInput(tag="in_sl", input_type=Int(optional=True), prefix="-sl", doc=InputDocumentation(doc=": subplot length (-sl 5000)")), ToolInput(tag="in_plt", input_type=Float(optional=True), prefix="-plt", doc=InputDocumentation(doc=": plot threshold, only plot if more than % of errors (-plt 0.0)")), ToolInput(tag="in_fn", input_type=String(optional=True), prefix="-fn", doc=InputDocumentation(doc=": figure name (default: contig name)")), ToolInput(tag="in_mps", input_type=Int(optional=True), prefix="-mps", doc=InputDocumentation(doc=": minimum plot size in bp (-mps 100)")), ToolInput(tag="in_sc", input_type=Int(optional=True), prefix="-sc", doc=InputDocumentation(doc=": plot only a specific contig (ie -sc contigName213)")), ToolInput(tag="in_pmo", input_type=Boolean(optional=True), prefix="-pmo", doc=InputDocumentation(doc=": plot meta information only (off)")), ToolInput(tag="in_dpm", input_type=Boolean(optional=True), prefix="-dpm", doc=InputDocumentation(doc=": don't plot meta information at all (off)")), ToolInput(tag="in_mgm", input_type=Int(optional=True), prefix="-mgm", doc=InputDocumentation(doc=": maximum gaussian mixtures (5)"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Plotter3_Py_V0_1_0().translate("wdl", allow_empty_container=True)

